/*
 * AssociationsBuilder.java
 *
 * Created on 28 September 2002
 */

package lifecycle;
import Vsml.repository.*;
import Vsml.repository.implementation.*;
import Vsml.AS.*;
import Vsml.AS.implementation.*;
import uk.ac.ukc.cs.kmf.ocl.*;
import uk.ac.ukc.cs.kmf.ocl.implementations.*;
import java.io.*;

/**
 *
 * @author  sjhk
 */
public class AssociationEndLifecycle extends Vsml.AS.implementation.AssociationEndLifecycle {
    
    /** Creates a new instance of AssociationEndLifecycle */
    protected AssociationEndLifecycle() {
        super();
    }
   
    public AssociationEndLifecycle(IVsmlRepository rep) {
        this.rep=rep;
    }
    
    public IAssociationEnd build(
        IClass source, IClass target,
        IString name, IInteger lowerBound, IInteger upperBound){
        IAssociationEnd end = (IAssociationEnd)build();
        end.setLower(lowerBound);
        end.setUpper(lowerBound);
        end.setName(name);
        end.setSource(source);
        end.setTarget(target);
        source.sourceOf().add(end);
        target.targetOf().add(end);
        return end;
    }
    
}
