/*
 * AssociationLifecycle.java
 *
 * Created on 28 September 2002
 */

package lifecycle;
import Vsml.repository.*;
import Vsml.repository.implementation.*;
import Vsml.AS.*;
import uk.ac.ukc.cs.kmf.ocl.*;
import uk.ac.ukc.cs.kmf.ocl.implementations.*;
import java.io.*;

/**
 *
 * @author  sjhk
 */
public class AssociationLifecycle extends Vsml.AS.implementation.AssociationLifecycle {
    
    /** Creates a new instance of AssociationEndLifecycle */
    protected AssociationLifecycle() {
        super();
    }
   
    public AssociationLifecycle(IVsmlRepository rep) {
        this.rep=rep;
    }
    
    //one end
    public IAssociation build(IPackage p,
        IClass source, IClass target,
        IString name, IInteger lowerBound, IInteger upperBound){
        IAssociation assoc = (IAssociation)build();
        lifecycle.AssociationEndLifecycle end_b = (lifecycle.AssociationEndLifecycle)(rep.getLifecycle("Vsml.AS.AssociationEnd"));
        IAssociationEnd end = end_b.build(source, target, name,lowerBound, upperBound);
        end.setOtherEnd(null);
        end.setOwner(assoc);
        assoc.associationEnd().add(end);
        p.association().add(assoc);
        assoc.setOwner(p);
        return assoc;
    }
    
    //two ends        
    public IAssociation build(IPackage p,
        IClass one_class, IClass other_class,
        IString one_name, IInteger one_lowerBound, IInteger one_upperBound,
        IString other_name, IInteger other_lowerBound, IInteger other_upperBound){
        IAssociation assoc = (IAssociation)build();
        lifecycle.AssociationEndLifecycle end_b = (lifecycle.AssociationEndLifecycle)(rep.getLifecycle("Vsml.AS.AssociationEnd"));
        IAssociationEnd one_end = end_b.build(one_class, other_class, one_name,one_lowerBound, one_upperBound);
        IAssociationEnd other_end = end_b.build(other_class, one_class, other_name,other_lowerBound, other_upperBound);        
        other_end.setOtherEnd(one_end);
        one_end.setOtherEnd(other_end);
        other_end.setOwner(assoc);
        one_end.setOwner(assoc);
        assoc.associationEnd().add(one_end);
        assoc.associationEnd().add(other_end);
        p.association().add(assoc);
        assoc.setOwner(p);
        return assoc;
    }
}
